# coding: utf-8

# psim を利用するためのおまじない -- ここから
import winreg, sys, os
reg = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE, "SOFTWARE\\Wow6432Node\\Mathematical Systems Inc.\\S-Quattro Simulation System\\INFO")
rootdir = winreg.QueryValueEx(reg, "ROOTDIR")[0]
os.environ["PATH"] = rootdir + ";" + os.environ["PATH"]
sys.path.insert(0, os.path.join(rootdir, "lib3"))
# psim を利用するためのおまじない -- ここまで

import venv
import msiversion
import subprocess
import shutil

sitepath0 = os.path.abspath(os.path.join("venv", "Lib", "site-packages"))
sitepath1 = os.path.dirname(msiversion.__file__)
pythonpath = f"{sitepath0}{os.path.pathsep}{sitepath1}"

venv.main(["venv"])
venvPython = os.path.abspath(os.path.join("venv", "Scripts", "python.exe"))
env = os.environ.copy()
env["PYTHONPATH"] = pythonpath

subprocess.run([venvPython, "-m", "pip", "install", "--upgrade", "pip"], env = env)
subprocess.run([venvPython, "-m", "pip", "install", "--upgrade", "xlwings"], env = env)
subprocess.run([venvPython, "-m", "pip", "install", "--upgrade", "pywin32"], env = env)

with open("xlwings.conf", "w") as f:
    print(f'"INTERPRETER_WIN","{venvPython}"', file = f)
    print(f'"PYTHONPATH","{sitepath0}{os.path.pathsep}{sitepath1}"', file = f)

shutil.copy("sim.py", sitepath0)
